Tonyu.klass.define({
  fullName: 'user.Boss',
  shortName: 'Boss',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Boss_main() {
        "use strict";
        var _this=this;
        var _it_15191;
        
        _this.p=3;
        
        
        _this.nowAttackName = "";
        
        while (_this.hp>0) {
          Tonyu.checkLoop();
          _this.act(_this,_this.f);
          _this.crashChk();
          _this.f+=1;
          _this.actf+=1;
          _this.update();
          
        }
        _it_15191=Tonyu.iterator(_this.attacks,1);
        while(_it_15191.next()) {
          _this.a=_it_15191[0];
          
          _this.a.endAttack();
          
        }
      },
      fiber$main :function _trc_Boss_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_15191;
        
        _this.p=3;
        
        
        _this.nowAttackName = "";
        
        
        _thread.enter(function _trc_Boss_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.hp>0)) { __pc=4     ; break; }
              _this.act(_this,_this.f);
              _this.fiber$crashChk(_thread);
              __pc=2;return;
            case 2:
              
              _this.f+=1;
              _this.actf+=1;
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
              __pc=1;break;
            case 4     :
              
              _it_15191=Tonyu.iterator(_this.attacks,1);
              while(_it_15191.next()) {
                _this.a=_it_15191[0];
                
                _this.a.endAttack();
                
              }
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_Boss_initialize(x,y,p,maxhp) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [x,y,p]);
        _this.vx=0;
        _this.vy=0;
        _this.maxhp=maxhp?maxhp:_this.maxhp;
        _this.hp=_this.maxhp;
        _this.f=0;
        _this.actf=0;
        _this.attacks=[];
        _this.attackState=- 1;
        Tonyu.globals.$bossmaxhp=_this.maxhp;
      },
      crashChk :function _trc_Boss_crashChk() {
        "use strict";
        var _this=this;
        
        do {
          Tonyu.checkLoop();
          _this.e=_this.crashTo(Tonyu.classes.user.Shot);
          if (! _this.e) {
            break;
            
          }
          _this.hp-=1;
          _this.e.die();
          
        } while (_this.e);
        
        Tonyu.globals.$bosshp=_this.hp;
      },
      fiber$crashChk :function _trc_Boss_f_crashChk(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Boss_ent_crashChk(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.e=_this.crashTo(Tonyu.classes.user.Shot);
              if (!(! _this.e)) { __pc=2     ; break; }
              __pc=4     ; break;
              
            case 2     :
              
              _this.hp-=1;
              _this.e.die();
            case 3     :
              if (_this.e) { __pc=1; break; }
            case 4     :
              
              Tonyu.globals.$bosshp=_this.hp;
              _thread.exit(_this);return;
            }
          }
        });
      },
      endAttack :function _trc_Boss_endAttack(atkName) {
        "use strict";
        var _this=this;
        
        if (_this.nowAttackName==atkName) {
          _this.isAttack=false;
          _this.nowAttackName="";
          
        }
        _this.f=0;
      },
      fiber$endAttack :function _trc_Boss_f_endAttack(_thread,atkName) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.nowAttackName==atkName) {
          _this.isAttack=false;
          _this.nowAttackName="";
          
        }
        _this.f=0;
        
        _thread.retVal=_this;return;
      },
      shot :function _trc_Boss_shot() {
        "use strict";
        var _this=this;
        var shot;
        
        shot = _this.appear(Tonyu.classes.user.BossTama,{x: _this.x,y: _this.y});
        
        shot.vy=_this.rnd(3)+1;
      },
      fiber$shot :function _trc_Boss_f_shot(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var shot;
        
        shot = _this.appear(Tonyu.classes.user.BossTama,{x: _this.x,y: _this.y});
        
        shot.vy=_this.rnd(3)+1;
        
        _thread.retVal=_this;return;
      },
      attack :function _trc_Boss_attack(atkFunc,atkName) {
        "use strict";
        var _this=this;
        var ba;
        
        ba = new Tonyu.classes.user.BossAttack(_this.x,_this.y,_this,atkFunc,atkName);
        
        _this.attacks.push(ba);
        _this.isAttack=true;
        _this.nowAttackName=atkName?atkName:"";
        return ba;
      },
      fiber$attack :function _trc_Boss_f_attack(_thread,atkFunc,atkName) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ba;
        
        ba = new Tonyu.classes.user.BossAttack(_this.x,_this.y,_this,atkFunc,atkName);
        
        _this.attacks.push(ba);
        _this.isAttack=true;
        _this.nowAttackName=atkName?atkName:"";
        _thread.retVal=ba;return;
        
        
        _thread.retVal=_this;return;
      },
      apendattack :function _trc_Boss_apendattack(atkFunc) {
        "use strict";
        var _this=this;
        var ba;
        
        ba = new Tonyu.classes.user.BossAttack(_this.x,_this.y,_this,atkFunc);
        
        return ba;
      },
      fiber$apendattack :function _trc_Boss_f_apendattack(_thread,atkFunc) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ba;
        
        ba = new Tonyu.classes.user.BossAttack(_this.x,_this.y,_this,atkFunc);
        
        _thread.retVal=ba;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"crashChk":{"nowait":false},"endAttack":{"nowait":false},"shot":{"nowait":false},"attack":{"nowait":false},"apendattack":{"nowait":false}},"fields":{"act":{},"isAttack":{},"nowAttackName":{},"hp":{},"f":{},"a":{},"attacks":{},"e":{}}}
});
Tonyu.klass.define({
  fullName: 'user.BossAttack',
  shortName: 'BossAttack',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_BossAttack_main() {
        "use strict";
        var _this=this;
        
        _this.f = 0;
        
        _this.tamas = [];
        
        _this.apatks = [];
        
        while (true) {
          Tonyu.checkLoop();
          _this.attack(_this,_this.f);
          _this.f+=1;
          _this.update();
          
        }
      },
      fiber$main :function _trc_BossAttack_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.f = 0;
        
        _this.tamas = [];
        
        _this.apatks = [];
        
        
        _thread.enter(function _trc_BossAttack_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.attack(_this,_this.f);
              _this.f+=1;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_BossAttack_initialize(x,y,parent,atkFunc,atkName) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [x,y,- 1]);
        _this.parent=parent;
        _this.attack=atkFunc;
        _this.atkName=atkName?atkName:"";
      },
      shot :function _trc_BossAttack_shot(tama) {
        "use strict";
        var _this=this;
        var t;
        
        t = _this.appear(Tonyu.classes.user.BossTama,{x: _this.x,y: _this.y,parent: _this});
        
        t.changeTama(tama);
        _this.tamas.push(t);
        return t;
      },
      fiber$shot :function _trc_BossAttack_f_shot(_thread,tama) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var t;
        
        t = _this.appear(Tonyu.classes.user.BossTama,{x: _this.x,y: _this.y,parent: _this});
        
        t.changeTama(tama);
        _this.tamas.push(t);
        _thread.retVal=t;return;
        
        
        _thread.retVal=_this;return;
      },
      eachTamas :function _trc_BossAttack_eachTamas(f) {
        "use strict";
        var _this=this;
        var _it_15197;
        
        _it_15197=Tonyu.iterator(_this.tamas,1);
        while(_it_15197.next()) {
          _this.tama=_it_15197[0];
          
          if (_this.tama.parent==_this) {
            f(_this.tama);
          }
          
        }
      },
      fiber$eachTamas :function _trc_BossAttack_f_eachTamas(_thread,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_15197;
        
        _it_15197=Tonyu.iterator(_this.tamas,1);
        while(_it_15197.next()) {
          _this.tama=_it_15197[0];
          
          if (_this.tama.parent==_this) {
            f(_this.tama);
          }
          
        }
        
        _thread.retVal=_this;return;
      },
      endAttack :function _trc_BossAttack_endAttack() {
        "use strict";
        var _this=this;
        var _it_15199;
        
        _this.parent.endAttack(_this.atkName);
        _it_15199=Tonyu.iterator(_this.apatks,1);
        while(_it_15199.next()) {
          _this.a=_it_15199[0];
          
          _this.a.endAttack();
          
        }
        _this.die();
      },
      fiber$endAttack :function _trc_BossAttack_f_endAttack(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var _it_15199;
        
        _this.parent.endAttack(_this.atkName);
        _it_15199=Tonyu.iterator(_this.apatks,1);
        while(_it_15199.next()) {
          _this.a=_it_15199[0];
          
          _this.a.endAttack();
          
        }
        _this.die();
        
        _thread.retVal=_this;return;
      },
      apendattack :function _trc_BossAttack_apendattack(atkFunc) {
        "use strict";
        var _this=this;
        var ba;
        
        ba = new Tonyu.classes.user.BossAttack(_this.parent.x,_this.parent.y,_this.parent,atkFunc);
        
        _this.apatks.push(ba);
        return ba;
      },
      fiber$apendattack :function _trc_BossAttack_f_apendattack(_thread,atkFunc) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ba;
        
        ba = new Tonyu.classes.user.BossAttack(_this.parent.x,_this.parent.y,_this.parent,atkFunc);
        
        _this.apatks.push(ba);
        _thread.retVal=ba;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"shot":{"nowait":false},"eachTamas":{"nowait":false},"endAttack":{"nowait":false},"apendattack":{"nowait":false}},"fields":{"f":{},"tamas":{},"apatks":{},"attack":{},"tama":{},"a":{}}}
});
Tonyu.klass.define({
  fullName: 'user.BossTama',
  shortName: 'BossTama',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_BossTama_main() {
        "use strict";
        var _this=this;
        
        _this.useObjectPool=true;
        _this.on("die",(function anonymous_1476() {
          
          _this.f=- 1;
        }));
        
        while (true) {
          Tonyu.checkLoop();
          _this.sx=_this.x;
          _this.sy=_this.y;
          _this.tamaAct(_this,_this.f);
          _this.x+=_this.vx;
          _this.y+=_this.vy;
          _this.f+=1;
          _this.update();
          
        }
      },
      fiber$main :function _trc_BossTama_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.useObjectPool=true;
        _this.on("die",(function anonymous_1476() {
          
          _this.f=- 1;
        }));
        
        
        _thread.enter(function _trc_BossTama_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.sx=_this.x;
              _this.sy=_this.y;
              _this.tamaAct(_this,_this.f);
              _this.x+=_this.vx;
              _this.y+=_this.vy;
              _this.f+=1;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_BossTama_initialize(x,y) {
        "use strict";
        var _this=this;
        
        __superClass.apply( _this, [x,y]);
        _this.zOrder=- 1;
        _this.tamaAct=(function anonymous_122(self) {
          
          _this.screenoutdie();
        });
        _this.vx=0;
        _this.vy=0;
        _this.spd=0;
        _this.f=0;
        _this.color=x.color?x.color:Tonyu.globals.$ctx.rgba(255,60,60,1);
        _this.parent=x.parent?x.parent:null;
      },
      changeTama :function _trc_BossTama_changeTama(t) {
        "use strict";
        var _this=this;
        var spd;
        
        t=Object.create(t);
        _this.tama=t;
        if (t.x||t.x==0) {
          _this.x=t.x;
        }
        if (t.y||t.y==0) {
          _this.y=t.y;
        }
        _this.tamaAct=t.act?t.act:_this.tamaAct;
        if (t.angle||t.angle==0) {
          if (t.angle=="Player") {
            t.angle=_this.atanxy(Tonyu.globals.$PlayerObj.x-_this.x,Tonyu.globals.$PlayerObj.y-_this.y);
          }
          spd = t.spd?t.spd:_this.spd;
          
          _this.spd=spd;
          _this.angle=t.angle;
          _this.vx=_this.cos(t.angle)*spd;
          _this.vy=_this.sin(t.angle)*spd;
          
        } else {
          _this.vx=t.vx?t.vx:0;
          _this.vy=t.vy?t.vy:0;
          
        }
        _this.size=t.size?t.size:_this.size;
        _this.r=_this.size/2;
        _this.color=t.color?t.color:_this.color;
        _this.f=0;
      },
      fiber$changeTama :function _trc_BossTama_f_changeTama(_thread,t) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var spd;
        
        t=Object.create(t);
        _this.tama=t;
        if (t.x||t.x==0) {
          _this.x=t.x;
        }
        if (t.y||t.y==0) {
          _this.y=t.y;
        }
        _this.tamaAct=t.act?t.act:_this.tamaAct;
        if (t.angle||t.angle==0) {
          if (t.angle=="Player") {
            t.angle=_this.atanxy(Tonyu.globals.$PlayerObj.x-_this.x,Tonyu.globals.$PlayerObj.y-_this.y);
          }
          spd = t.spd?t.spd:_this.spd;
          
          _this.spd=spd;
          _this.angle=t.angle;
          _this.vx=_this.cos(t.angle)*spd;
          _this.vy=_this.sin(t.angle)*spd;
          
        } else {
          _this.vx=t.vx?t.vx:0;
          _this.vy=t.vy?t.vy:0;
          
        }
        _this.size=t.size?t.size:_this.size;
        _this.r=_this.size/2;
        _this.color=t.color?t.color:_this.color;
        _this.f=0;
        
        _thread.retVal=_this;return;
      },
      getCrashRect :function _trc_BossTama_getCrashRect() {
        "use strict";
        var _this=this;
        
        return {x: _this.x,y: _this.y,width: _this.size,height: _this.size};
      },
      draw :function _trc_BossTama_draw(ctx) {
        "use strict";
        var _this=this;
        var scale;
        var size;
        var white;
        
        scale = 1;
        
        size = _this.size;
        
        ctx.strokeStyle=Tonyu.globals.$ctx.rgba(255,255,255,1);
        white = Tonyu.globals.$ctx.color(255,255,255,0.7);
        
        ctx.fillStyle=_this.color;
        Tonyu.globals.$ctx.circle(ctx,_this.x,_this.y,size*scale,true);
        Tonyu.globals.$ctx.circle(ctx,_this.x,_this.y,size*scale,false);
      },
      spdChange :function _trc_BossTama_spdChange(value) {
        "use strict";
        var _this=this;
        
        _this.spd=value;
        _this.vx=_this.cos(_this.angle)*_this.spd;
        _this.vy=_this.sin(_this.angle)*_this.spd;
      },
      fiber$spdChange :function _trc_BossTama_f_spdChange(_thread,value) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.spd=value;
        _this.vx=_this.cos(_this.angle)*_this.spd;
        _this.vy=_this.sin(_this.angle)*_this.spd;
        
        _thread.retVal=_this;return;
      },
      screenoutdie :function _trc_BossTama_screenoutdie() {
        "use strict";
        var _this=this;
        
        if (_this.screenOut()>_this.r) {
          _this.die();
        }
      },
      fiber$screenoutdie :function _trc_BossTama_f_screenoutdie(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.screenOut()>_this.r) {
          _this.die();
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"changeTama":{"nowait":false},"getCrashRect":{"nowait":true},"draw":{"nowait":true},"spdChange":{"nowait":false},"screenoutdie":{"nowait":false}},"fields":{"sx":{},"sy":{},"tamaAct":{},"f":{},"vx":{},"vy":{},"r":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Ctx',
  shortName: 'Ctx',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Ctx_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Ctx_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      fillRect :function _trc_Ctx_fillRect(ctx,x,y,w,h,scale) {
        "use strict";
        var _this=this;
        var wsize;
        var hsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        ctx.fill();
      },
      rect :function _trc_Ctx_rect(ctx,x,y,w,h,scale,isFill) {
        "use strict";
        var _this=this;
        var wsize;
        var hsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$rect :function _trc_Ctx_f_rect(_thread,ctx,x,y,w,h,scale,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var wsize;
        var hsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      rectFrame :function _trc_Ctx_rectFrame(ctx,x,y,w,h,iw,ih,scale,isFill) {
        "use strict";
        var _this=this;
        var wsize;
        var hsize;
        var iwsize;
        var ihsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        iwsize = iw*scale;
        
        ihsize = ih*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        ctx.moveTo(x-iwsize/2,y-ihsize/2);
        ctx.lineTo(x+iwsize/2,y-ihsize/2);
        ctx.lineTo(x+iwsize/2,y+ihsize/2);
        ctx.lineTo(x-iwsize/2,y+ihsize/2);
        ctx.lineTo(x-iwsize/2,y-ihsize/2);
        ctx.fill("evenodd");
      },
      fiber$rectFrame :function _trc_Ctx_f_rectFrame(_thread,ctx,x,y,w,h,iw,ih,scale,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var wsize;
        var hsize;
        var iwsize;
        var ihsize;
        
        wsize = w*scale;
        
        hsize = h*scale;
        
        iwsize = iw*scale;
        
        ihsize = ih*scale;
        
        ctx.beginPath();
        ctx.moveTo(x-wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y-hsize/2);
        ctx.lineTo(x+wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y+hsize/2);
        ctx.lineTo(x-wsize/2,y-hsize/2);
        ctx.moveTo(x-iwsize/2,y-ihsize/2);
        ctx.lineTo(x+iwsize/2,y-ihsize/2);
        ctx.lineTo(x+iwsize/2,y+ihsize/2);
        ctx.lineTo(x-iwsize/2,y+ihsize/2);
        ctx.lineTo(x-iwsize/2,y-ihsize/2);
        ctx.fill("evenodd");
        
        _thread.retVal=_this;return;
      },
      triangle :function _trc_Ctx_triangle(ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        
        ctx.beginPath();
        ctx.moveTo(x,y-size/2);
        ctx.lineTo(x+size/2,y+size/2);
        ctx.lineTo(x-size/2,y+size/2);
        ctx.lineTo(x,y-size/2);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$triangle :function _trc_Ctx_f_triangle(_thread,ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        ctx.beginPath();
        ctx.moveTo(x,y-size/2);
        ctx.lineTo(x+size/2,y+size/2);
        ctx.lineTo(x-size/2,y+size/2);
        ctx.lineTo(x,y-size/2);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      circle :function _trc_Ctx_circle(ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        
        ctx.beginPath();
        ctx.arc(x,y,size/2,0,Tonyu.globals.$Math.PI*2,true);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$circle :function _trc_Ctx_f_circle(_thread,ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        ctx.beginPath();
        ctx.arc(x,y,size/2,0,Tonyu.globals.$Math.PI*2,true);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      moon :function _trc_Ctx_moon(ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        var startAngle;
        var endAngle;
        
        startAngle = 270*Tonyu.globals.$Math.PI/180;
        
        endAngle = 180*Tonyu.globals.$Math.PI/180;
        
        ctx.beginPath();
        ctx.arc(x,y,size/2,startAngle,endAngle,false);
        ctx.arc(x-size/5,y-size/5,size/3,endAngle,startAngle,true);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$moon :function _trc_Ctx_f_moon(_thread,ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var startAngle;
        var endAngle;
        
        startAngle = 270*Tonyu.globals.$Math.PI/180;
        
        endAngle = 180*Tonyu.globals.$Math.PI/180;
        
        ctx.beginPath();
        ctx.arc(x,y,size/2,startAngle,endAngle,false);
        ctx.arc(x-size/5,y-size/5,size/3,endAngle,startAngle,true);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      sparkle :function _trc_Ctx_sparkle(ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        var startAngle;
        var endAngle;
        
        startAngle = 270*Tonyu.globals.$Math.PI/180;
        
        endAngle = 180*Tonyu.globals.$Math.PI/180;
        
        size/=1.75;
        _this.qsize=size/4;
        ctx.beginPath();
        ctx.moveTo(x-size,y);
        ctx.quadraticCurveTo(x-_this.qsize,y-_this.qsize,x,y-size);
        ctx.quadraticCurveTo(x+_this.qsize,y-_this.qsize,x+size,y);
        ctx.quadraticCurveTo(x+_this.qsize,y+_this.qsize,x,y+size);
        ctx.quadraticCurveTo(x-_this.qsize,y+_this.qsize,x-size,y);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
      },
      fiber$sparkle :function _trc_Ctx_f_sparkle(_thread,ctx,x,y,size,isFill) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var startAngle;
        var endAngle;
        
        startAngle = 270*Tonyu.globals.$Math.PI/180;
        
        endAngle = 180*Tonyu.globals.$Math.PI/180;
        
        size/=1.75;
        _this.qsize=size/4;
        ctx.beginPath();
        ctx.moveTo(x-size,y);
        ctx.quadraticCurveTo(x-_this.qsize,y-_this.qsize,x,y-size);
        ctx.quadraticCurveTo(x+_this.qsize,y-_this.qsize,x+size,y);
        ctx.quadraticCurveTo(x+_this.qsize,y+_this.qsize,x,y+size);
        ctx.quadraticCurveTo(x-_this.qsize,y+_this.qsize,x-size,y);
        if (isFill) {
          ctx.fill();
        } else {
          ctx.stroke();
        }
        
        _thread.retVal=_this;return;
      },
      rgba :function _trc_Ctx_rgba(r,g,b,a) {
        "use strict";
        var _this=this;
        
        return "rgba("+r+","+g+","+b+", "+a+")";
      },
      fiber$rgba :function _trc_Ctx_f_rgba(_thread,r,g,b,a) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal="rgba("+r+","+g+","+b+", "+a+")";return;
        
        
        _thread.retVal=_this;return;
      },
      rgbaString :function _trc_Ctx_rgbaString(color) {
        "use strict";
        var _this=this;
        
        return "rgba("+color.r+","+color.g+","+color.b+", "+color.a+")";
      },
      fiber$rgbaString :function _trc_Ctx_f_rgbaString(_thread,color) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal="rgba("+color.r+","+color.g+","+color.b+", "+color.a+")";return;
        
        
        _thread.retVal=_this;return;
      },
      color :function _trc_Ctx_color(r,g,b,a) {
        "use strict";
        var _this=this;
        var col;
        
        col = {};
        
        col.r=r;
        col.g=g;
        col.b=b;
        col.a=a;
        return col;
      },
      colorMix :function _trc_Ctx_colorMix(colA,colB,rate) {
        "use strict";
        var _this=this;
        var ar;
        var br;
        var colC;
        
        ar = 1-rate;
        
        br = rate;
        
        colC = {};
        
        colC.r=colA.r*ar+colB.r*br;
        colC.g=colA.g*ar+colB.g*br;
        colC.b=colA.b*ar+colB.b*br;
        colC.a=colA.a*ar+colB.a*br;
        return colC;
      },
      fiber$colorMix :function _trc_Ctx_f_colorMix(_thread,colA,colB,rate) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var ar;
        var br;
        var colC;
        
        ar = 1-rate;
        
        br = rate;
        
        colC = {};
        
        colC.r=colA.r*ar+colB.r*br;
        colC.g=colA.g*ar+colB.g*br;
        colC.b=colA.b*ar+colB.b*br;
        colC.a=colA.a*ar+colB.a*br;
        _thread.retVal=colC;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"fillRect":{"nowait":true},"rect":{"nowait":false},"rectFrame":{"nowait":false},"triangle":{"nowait":false},"circle":{"nowait":false},"moon":{"nowait":false},"sparkle":{"nowait":false},"rgba":{"nowait":false},"rgbaString":{"nowait":false},"color":{"nowait":true},"colorMix":{"nowait":false}},"fields":{"qsize":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Ease',
  shortName: 'Ease',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Ease_main() {
        "use strict";
        var _this=this;
        
        _this.type = [];
        
        _this.type[1]=Tonyu.bindFunc(_this,_this.linear);
        _this.type[14]=Tonyu.bindFunc(_this,_this.easeInQuart);
        _this.type[15]=Tonyu.bindFunc(_this,_this.easeOutQuart);
        _this.type[22]=Tonyu.bindFunc(_this,_this.easeInExpo);
        _this.type[23]=Tonyu.bindFunc(_this,_this.easeOutExpo);
        ;
        
        ;
        
        ;
        
        ;
        
        ;
        
      },
      fiber$main :function _trc_Ease_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.type = [];
        
        _this.type[1]=Tonyu.bindFunc(_this,_this.linear);
        _this.type[14]=Tonyu.bindFunc(_this,_this.easeInQuart);
        _this.type[15]=Tonyu.bindFunc(_this,_this.easeOutQuart);
        _this.type[22]=Tonyu.bindFunc(_this,_this.easeInExpo);
        _this.type[23]=Tonyu.bindFunc(_this,_this.easeOutExpo);
        ;
        
        ;
        
        ;
        
        ;
        
        ;
        
        
        _thread.retVal=_this;return;
      },
      linear :function _trc_Ease_linear(t,b,c,d) {
        "use strict";
        var _this=this;
        
        return c*t/d+b;
      },
      fiber$linear :function _trc_Ease_f_linear(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=c*t/d+b;return;
        
        
        _thread.retVal=_this;return;
      },
      easeInQuart :function _trc_Ease_easeInQuart(t,b,c,d) {
        "use strict";
        var _this=this;
        
        t/=d;
        return c*t*t*t*t+b;
      },
      fiber$easeInQuart :function _trc_Ease_f_easeInQuart(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        t/=d;
        _thread.retVal=c*t*t*t*t+b;return;
        
        
        _thread.retVal=_this;return;
      },
      easeOutQuart :function _trc_Ease_easeOutQuart(t,b,c,d) {
        "use strict";
        var _this=this;
        
        t/=d;
        t--;
        return - c*(t*t*t*t-1)+b;
      },
      fiber$easeOutQuart :function _trc_Ease_f_easeOutQuart(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        t/=d;
        t--;
        _thread.retVal=- c*(t*t*t*t-1)+b;return;
        
        
        _thread.retVal=_this;return;
      },
      easeInExpo :function _trc_Ease_easeInExpo(t,b,c,d) {
        "use strict";
        var _this=this;
        
        return c*Tonyu.globals.$Math.pow(2,10*(t/d-1))+b;
      },
      fiber$easeInExpo :function _trc_Ease_f_easeInExpo(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=c*Tonyu.globals.$Math.pow(2,10*(t/d-1))+b;return;
        
        
        _thread.retVal=_this;return;
      },
      easeOutExpo :function _trc_Ease_easeOutExpo(t,b,c,d) {
        "use strict";
        var _this=this;
        
        return c*(- Tonyu.globals.$Math.pow(2,- 10*t/d)+1)+b;
      },
      fiber$easeOutExpo :function _trc_Ease_f_easeOutExpo(_thread,t,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=c*(- Tonyu.globals.$Math.pow(2,- 10*t/d)+1)+b;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"linear":{"nowait":false},"easeInQuart":{"nowait":false},"easeOutQuart":{"nowait":false},"easeInExpo":{"nowait":false},"easeOutExpo":{"nowait":false}},"fields":{"type":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Line',
  shortName: 'Line',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Line_main() {
        "use strict";
        var _this=this;
        
        if (_this.sx==null) {
          _this.sx=_this.x!=null?_this.x:0;
        }
        if (_this.sy==null) {
          _this.sy=_this.y!=null?_this.y:0;
        }
        _this.color=Tonyu.bindFunc(_this,_this.color)==null?"#ffffff":Tonyu.bindFunc(_this,_this.color);
      },
      fiber$main :function _trc_Line_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        if (_this.sx==null) {
          _this.sx=_this.x!=null?_this.x:0;
        }
        if (_this.sy==null) {
          _this.sy=_this.y!=null?_this.y:0;
        }
        _this.color=Tonyu.bindFunc(_this,_this.color)==null?"#ffffff":Tonyu.bindFunc(_this,_this.color);
        
        _thread.retVal=_this;return;
      },
      setLine :function _trc_Line_setLine(l) {
        "use strict";
        var _this=this;
        
        _this.x=l[0].x;
        _this.y=l[0].y;
        _this.ex=l[1].x;
        _this.ey=l[1].y;
        _this.color="#ffffff";
      },
      fiber$setLine :function _trc_Line_f_setLine(_thread,l) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.x=l[0].x;
        _this.y=l[0].y;
        _this.ex=l[1].x;
        _this.ey=l[1].y;
        _this.color="#ffffff";
        
        _thread.retVal=_this;return;
      },
      draw :function _trc_Line_draw(ctx) {
        "use strict";
        var _this=this;
        
        ctx.strokeStyle=Tonyu.bindFunc(_this,_this.color);
        ctx.beginPath();
        ctx.moveTo(_this.x,_this.y);
        ctx.lineTo(_this.ex,_this.ey);
        ctx.stroke();
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"setLine":{"nowait":false},"draw":{"nowait":true}},"fields":{"sx":{},"sy":{},"ex":{},"ey":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$Screen.resize(400,500);
        Tonyu.globals.$Screen.setBGColor("#000");
        Tonyu.globals.$ease=new Tonyu.classes.user.Ease();
        Tonyu.globals.$ctx=new Tonyu.classes.user.Ctx();
        Tonyu.globals.$utils=new Tonyu.classes.user.Utils();
        new Tonyu.classes.user.Title();
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$Screen.resize(400,500);
        Tonyu.globals.$Screen.setBGColor("#000");
        Tonyu.globals.$ease=new Tonyu.classes.user.Ease();
        Tonyu.globals.$ctx=new Tonyu.classes.user.Ctx();
        Tonyu.globals.$utils=new Tonyu.classes.user.Utils();
        new Tonyu.classes.user.Title();
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Player',
  shortName: 'Player',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Player_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$PlayerObj=_this;
        _this.p=0;
        _this.r=2;
        _this.zOrder=1;
        _this.chkLine=new Tonyu.classes.user.Line({});
        new Tonyu.classes.user.PlayerHitCircle(_this);
        _this.zurex = 0;
        
        _this.zurey = 0;
        
        _this.nx = _this.x;
        
        _this.ny = _this.y;
        
        while (true) {
          Tonyu.checkLoop();
          if (Tonyu.globals.$getkey("left")&&_this.nx>0+_this.r) {
            _this.nx=_this.x-3;
            
          }
          if (Tonyu.globals.$getkey("right")&&_this.nx<400-_this.r) {
            _this.nx=_this.x+3;
            
          }
          if (Tonyu.globals.$getkey("up")&&_this.ny>0+_this.r) {
            _this.ny=_this.y-3;
            
          }
          if (Tonyu.globals.$getkey("down")&&_this.ny<500-_this.r) {
            _this.ny=_this.y+3;
            
          }
          if (Tonyu.globals.$touches[0].touched) {
            _this.nx+=Tonyu.globals.$touches[0].vx;
            _this.ny+=Tonyu.globals.$touches[0].vy;
            
          }
          _this.crashChkBossTamaMoveTo(_this.nx,_this.ny);
          _this.x=_this.nx;
          _this.y=_this.ny;
          if (_this.x>400-_this.r) {
            _this.x=400-_this.r;
          }
          if (_this.x<0+_this.r) {
            _this.x=0+_this.r;
          }
          if (_this.y>500-_this.r) {
            _this.y=500-_this.r;
          }
          if (_this.y<0+_this.r) {
            _this.y=0+_this.r;
          }
          new Tonyu.classes.user.Shot(_this.x-10,_this.y);
          new Tonyu.classes.user.Shot(_this.x+10,_this.y);
          Tonyu.globals.$time+=1;
          _this.update();
          
        }
      },
      fiber$main :function _trc_Player_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$PlayerObj=_this;
        _this.p=0;
        _this.r=2;
        _this.zOrder=1;
        _this.chkLine=new Tonyu.classes.user.Line({});
        new Tonyu.classes.user.PlayerHitCircle(_this);
        _this.zurex = 0;
        
        _this.zurey = 0;
        
        _this.nx = _this.x;
        
        _this.ny = _this.y;
        
        
        _thread.enter(function _trc_Player_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (Tonyu.globals.$getkey("left")&&_this.nx>0+_this.r) {
                _this.nx=_this.x-3;
                
              }
              if (Tonyu.globals.$getkey("right")&&_this.nx<400-_this.r) {
                _this.nx=_this.x+3;
                
              }
              if (Tonyu.globals.$getkey("up")&&_this.ny>0+_this.r) {
                _this.ny=_this.y-3;
                
              }
              if (Tonyu.globals.$getkey("down")&&_this.ny<500-_this.r) {
                _this.ny=_this.y+3;
                
              }
              if (Tonyu.globals.$touches[0].touched) {
                _this.nx+=Tonyu.globals.$touches[0].vx;
                _this.ny+=Tonyu.globals.$touches[0].vy;
                
              }
              _this.fiber$crashChkBossTamaMoveTo(_thread, _this.nx, _this.ny);
              __pc=2;return;
            case 2:
              
              _this.x=_this.nx;
              _this.y=_this.ny;
              if (_this.x>400-_this.r) {
                _this.x=400-_this.r;
              }
              if (_this.x<0+_this.r) {
                _this.x=0+_this.r;
              }
              if (_this.y>500-_this.r) {
                _this.y=500-_this.r;
              }
              if (_this.y<0+_this.r) {
                _this.y=0+_this.r;
              }
              new Tonyu.classes.user.Shot(_this.x-10,_this.y);
              new Tonyu.classes.user.Shot(_this.x+10,_this.y);
              Tonyu.globals.$time+=1;
              _this.fiber$update(_thread);
              __pc=3;return;
            case 3:
              
              __pc=1;break;
            case 4     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      crashChkBossTamaMoveTo :function _trc_Player_crashChkBossTamaMoveTo(nx,ny) {
        "use strict";
        var _this=this;
        var nline;
        var lx;
        var uy;
        var rx;
        var dy;
        var angle;
        var isHit;
        var _it_15223;
        var el;
        
        nline = Tonyu.globals.$utils.newLine(_this.x,_this.y,nx,ny);
        
        nline=Tonyu.globals.$utils.lineExtendBoth(nline,_this.r);
        _this.chkLine.setLine(nline);
        lx = Tonyu.globals.$utils.min(nx,_this.x)-_this.r;
        
        uy = Tonyu.globals.$utils.min(ny,_this.y)-_this.r;
        
        rx = Tonyu.globals.$utils.max(nx,_this.x)+_this.r;
        
        dy = Tonyu.globals.$utils.max(ny,_this.y)+_this.r;
        
        angle = _this.atanxy(nx-_this.x,ny-_this.y)+90;
        
        isHit = 0;
        
        _it_15223=Tonyu.iterator(_this.all(Tonyu.classes.user.BossTama),1);
        while(_it_15223.next()) {
          _this.e=_it_15223[0];
          
          el = Tonyu.globals.$utils.newLineFromCenter(_this.e.x,_this.e.y,angle,_this.e.r+_this.r);
          
          if (_this.e.x+_this.e.r>lx&&_this.e.x-_this.e.r<rx&&_this.e.y+_this.e.r>uy&&_this.e.y-_this.e.r<dy) {
            if (_this.within(_this.e,_this.e.r)||_this.isLineHitBossTama(nline,angle,_this.e)) {
              _this.onDamage(_this.e);
              _this.e.die();
              break;
              
              
            }
            
          }
          
        }
      },
      fiber$crashChkBossTamaMoveTo :function _trc_Player_f_crashChkBossTamaMoveTo(_thread,nx,ny) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var nline;
        var lx;
        var uy;
        var rx;
        var dy;
        var angle;
        var isHit;
        var _it_15223;
        var el;
        
        nline = Tonyu.globals.$utils.newLine(_this.x,_this.y,nx,ny);
        
        nline=Tonyu.globals.$utils.lineExtendBoth(nline,_this.r);
        _this.chkLine.setLine(nline);
        lx = Tonyu.globals.$utils.min(nx,_this.x)-_this.r;
        
        uy = Tonyu.globals.$utils.min(ny,_this.y)-_this.r;
        
        rx = Tonyu.globals.$utils.max(nx,_this.x)+_this.r;
        
        dy = Tonyu.globals.$utils.max(ny,_this.y)+_this.r;
        
        angle = _this.atanxy(nx-_this.x,ny-_this.y)+90;
        
        isHit = 0;
        
        
        _thread.enter(function _trc_Player_ent_crashChkBossTamaMoveTo(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _it_15223=Tonyu.iterator(_this.all(Tonyu.classes.user.BossTama),1);
            case 1:
              if (!(_it_15223.next())) { __pc=5     ; break; }
              _this.e=_it_15223[0];
              
              el = Tonyu.globals.$utils.newLineFromCenter(_this.e.x,_this.e.y,angle,_this.e.r+_this.r);
              
              if (!(_this.e.x+_this.e.r>lx&&_this.e.x-_this.e.r<rx&&_this.e.y+_this.e.r>uy&&_this.e.y-_this.e.r<dy)) { __pc=4     ; break; }
              if (!(_this.within(_this.e,_this.e.r)||_this.isLineHitBossTama(nline,angle,_this.e))) { __pc=3     ; break; }
              _this.fiber$onDamage(_thread, _this.e);
              __pc=2;return;
            case 2:
              
              _this.e.die();
              __pc=5     ; break;
              
            case 3     :
              
            case 4     :
              
              __pc=1;break;
            case 5     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      isLineHitBossTama :function _trc_Player_isLineHitBossTama(line,angle,e) {
        "use strict";
        var _this=this;
        var el;
        var hitPoint;
        
        el = Tonyu.globals.$utils.newLineFromCenter(e.x,e.y,angle,e.r+_this.r);
        
        hitPoint = Tonyu.globals.$utils.calcIntersectionPoint2(line,el);
        
        return hitPoint;
      },
      fiber$isLineHitBossTama :function _trc_Player_f_isLineHitBossTama(_thread,line,angle,e) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var el;
        var hitPoint;
        
        el = Tonyu.globals.$utils.newLineFromCenter(e.x,e.y,angle,e.r+_this.r);
        
        hitPoint = Tonyu.globals.$utils.calcIntersectionPoint2(line,el);
        
        _thread.retVal=hitPoint;return;
        
        
        _thread.retVal=_this;return;
      },
      onDamage :function _trc_Player_onDamage(t) {
        "use strict";
        var _this=this;
        
        _this.p=_this.rnd(11);
        Tonyu.globals.$hitCnt+=1;
      },
      fiber$onDamage :function _trc_Player_f_onDamage(_thread,t) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.p=_this.rnd(11);
        Tonyu.globals.$hitCnt+=1;
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"crashChkBossTamaMoveTo":{"nowait":false},"isLineHitBossTama":{"nowait":false},"onDamage":{"nowait":false}},"fields":{"zurex":{},"zurey":{},"nx":{},"ny":{},"r":{},"chkLine":{},"e":{}}}
});
Tonyu.klass.define({
  fullName: 'user.PlayerHitCircle',
  shortName: 'PlayerHitCircle',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_PlayerHitCircle_main() {
        "use strict";
        var _this=this;
        
        _this.x=_this.t.x;
        _this.y=_this.t.y;
        while (true) {
          Tonyu.checkLoop();
          _this.x=_this.t.x;
          _this.y=_this.t.y;
          _this.update();
          
        }
      },
      fiber$main :function _trc_PlayerHitCircle_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.x=_this.t.x;
        _this.y=_this.t.y;
        
        _thread.enter(function _trc_PlayerHitCircle_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.x=_this.t.x;
              _this.y=_this.t.y;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      initialize :function _trc_PlayerHitCircle_initialize(t) {
        "use strict";
        var _this=this;
        
        _this.x=t.x;
        _this.y=t.y;
        __superClass.apply( _this, [_this.x,_this.y]);
        _this.t=t;
        _this.vx=0;
        _this.vy=0;
        _this.zOrder=- 1;
        _this.r=t.r;
      },
      draw :function _trc_PlayerHitCircle_draw(ctx) {
        "use strict";
        var _this=this;
        var scale;
        var size;
        
        scale = 1;
        
        size = _this.r*2+1;
        
        ctx.strokeStyle=Tonyu.globals.$ctx.rgba(255,255,255,1);
        ctx.fillStyle=Tonyu.globals.$ctx.rgba(200,200,200,1);
        Tonyu.globals.$ctx.circle(ctx,_this.x,_this.y,size*scale,true);
        Tonyu.globals.$ctx.circle(ctx,_this.x,_this.y,size*scale,false);
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"new":{"nowait":false},"draw":{"nowait":true}},"fields":{"t":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Result',
  shortName: 'Result',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Result_main() {
        "use strict";
        var _this=this;
        
      },
      fiber$main :function _trc_Result_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Shot',
  shortName: 'Shot',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Shot_main() {
        "use strict";
        var _this=this;
        
        _this.p=25;
        _this.zOrder=2;
        while (_this.y>- 20) {
          Tonyu.checkLoop();
          _this.y-=16;
          _this.update();
          
        }
        _this.die();
      },
      fiber$main :function _trc_Shot_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.p=25;
        _this.zOrder=2;
        
        _thread.enter(function _trc_Shot_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              if (!(_this.y>- 20)) { __pc=3     ; break; }
              _this.y-=16;
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.die();
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Stage01',
  shortName: 'Stage01',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Stage01_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$stage=_this;
        Tonyu.globals.$stageName="Stage01";
        Tonyu.globals.$hitCnt=0;
        Tonyu.globals.$time=0;
        _this.player = new Tonyu.classes.user.Player({x: 200,y: 350});
        
        _this.boss = new Tonyu.classes.user.Boss({x: 200,y: 50,maxhp: 2000});
        
        new Tonyu.classes.user.StageUI();
        _this.boss.vx=2;
        _this.boss.halfflag=0;
        _this.boss.attackState=0;
        _this.tamakasoku = (function anonymous_335(tama,f) {
          
          if (f>15&&f<60) {
            tama.spdChange(tama.spd+0.05);
            
          }
          if (f>120) {
            tama.screenoutdie();
          }
        });
        
        _this.tamaTargetPlayer = {angle: "Player",spd: 0,color: Tonyu.globals.$ctx.rgba(60,60,60,1),act: _this.tamakasoku};
        
        _this.boss.act=(function anonymous_582(boss,f) {
          var d;
          var dd;
          var _it_15241;
          
          if (boss.halfflag) {
            boss.x+=boss.vx;
            if (boss.x<50||boss.x>350) {
              boss.vx=- boss.vx;
              
            }
            if (! boss.isAttack&&f>=30) {
              d = boss.attackState;
              
              if (d==0) {
                boss.attack(Tonyu.bindFunc(_this,_this.attackC),"attackC");
                
              } else {
                if (d==1) {
                  boss.attack(Tonyu.bindFunc(_this,_this.attackD));
                  
                } else {
                  if (d==2) {
                    boss.attack(Tonyu.bindFunc(_this,_this.attackA));
                    
                  } else {
                    dd = _this.rnd(3);
                    
                    if (dd==0) {
                      boss.attack(Tonyu.bindFunc(_this,_this.attackA));
                    }
                    if (dd==1) {
                      boss.attack(Tonyu.bindFunc(_this,_this.attackD));
                    }
                    if (dd==2) {
                      boss.attack(Tonyu.bindFunc(_this,_this.attackC),"attackC");
                    }
                    
                  }
                }
              }
              boss.attackState+=1;
              if (boss.attackState>=3) {
                boss.attackState=0;
              }
              
            }
            
          } else {
            if (! boss.isAttack) {
              boss.x+=boss.vx;
              if (boss.x<50||boss.x>350) {
                boss.vx=- boss.vx;
                
              }
              if (f==60) {
                boss.attack(Tonyu.bindFunc(_this,_this.attackA));
              }
              
            }
            if (boss.hp<boss.maxhp/2&&boss.halfflag==0) {
              _it_15241=Tonyu.iterator(_this.all(Tonyu.classes.user.BossTama),1);
              while(_it_15241.next()) {
                _this.e=_it_15241[0];
                
                _this.e.changeTama(_this.tamaTargetPlayer);
                
              }
              boss.halfflag=1;
              boss.vx=boss.vx*2;
              boss.attackState=0;
              
            }
            
          }
        });
      },
      fiber$main :function _trc_Stage01_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$stage=_this;
        Tonyu.globals.$stageName="Stage01";
        Tonyu.globals.$hitCnt=0;
        Tonyu.globals.$time=0;
        _this.player = new Tonyu.classes.user.Player({x: 200,y: 350});
        
        _this.boss = new Tonyu.classes.user.Boss({x: 200,y: 50,maxhp: 2000});
        
        new Tonyu.classes.user.StageUI();
        _this.boss.vx=2;
        _this.boss.halfflag=0;
        _this.boss.attackState=0;
        _this.tamakasoku = (function anonymous_335(tama,f) {
          
          if (f>15&&f<60) {
            tama.spdChange(tama.spd+0.05);
            
          }
          if (f>120) {
            tama.screenoutdie();
          }
        });
        
        _this.tamaTargetPlayer = {angle: "Player",spd: 0,color: Tonyu.globals.$ctx.rgba(60,60,60,1),act: _this.tamakasoku};
        
        _this.boss.act=(function anonymous_582(boss,f) {
          var d;
          var dd;
          var _it_15241;
          
          if (boss.halfflag) {
            boss.x+=boss.vx;
            if (boss.x<50||boss.x>350) {
              boss.vx=- boss.vx;
              
            }
            if (! boss.isAttack&&f>=30) {
              d = boss.attackState;
              
              if (d==0) {
                boss.attack(Tonyu.bindFunc(_this,_this.attackC),"attackC");
                
              } else {
                if (d==1) {
                  boss.attack(Tonyu.bindFunc(_this,_this.attackD));
                  
                } else {
                  if (d==2) {
                    boss.attack(Tonyu.bindFunc(_this,_this.attackA));
                    
                  } else {
                    dd = _this.rnd(3);
                    
                    if (dd==0) {
                      boss.attack(Tonyu.bindFunc(_this,_this.attackA));
                    }
                    if (dd==1) {
                      boss.attack(Tonyu.bindFunc(_this,_this.attackD));
                    }
                    if (dd==2) {
                      boss.attack(Tonyu.bindFunc(_this,_this.attackC),"attackC");
                    }
                    
                  }
                }
              }
              boss.attackState+=1;
              if (boss.attackState>=3) {
                boss.attackState=0;
              }
              
            }
            
          } else {
            if (! boss.isAttack) {
              boss.x+=boss.vx;
              if (boss.x<50||boss.x>350) {
                boss.vx=- boss.vx;
                
              }
              if (f==60) {
                boss.attack(Tonyu.bindFunc(_this,_this.attackA));
              }
              
            }
            if (boss.hp<boss.maxhp/2&&boss.halfflag==0) {
              _it_15241=Tonyu.iterator(_this.all(Tonyu.classes.user.BossTama),1);
              while(_it_15241.next()) {
                _this.e=_it_15241[0];
                
                _this.e.changeTama(_this.tamaTargetPlayer);
                
              }
              boss.halfflag=1;
              boss.vx=boss.vx*2;
              boss.attackState=0;
              
            }
            
          }
        });
        
        _thread.retVal=_this;return;
      },
      attackA :function _trc_Stage01_attackA(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        a.shot({x: boss.x,y: boss.y,angle: 70+_this.rnd(40),spd: 1+_this.rnd(5)/10,size: 10});
        if (f>60) {
          a.endAttack();
        }
      },
      fiber$attackA :function _trc_Stage01_f_attackA(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        a.shot({x: boss.x,y: boss.y,angle: 70+_this.rnd(40),spd: 1+_this.rnd(5)/10,size: 10});
        if (f>60) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      attackB :function _trc_Stage01_attackB(a,f) {
        "use strict";
        var _this=this;
        var boss;
        var i;
        
        boss = a.parent;
        
        if (f==0) {
          i = 0;
          for (; i<9 ; i++) {
            Tonyu.checkLoop();
            {
              a.shot({angle: i*45,spd: 1.5,size: 20,act: (function anonymous_2246(tama,f) {
                
                if (f==60) {
                  tama.changeTama(_this.tamaTargetPlayer);
                }
              })});
            }
          }
          
        }
        if (f>60) {
          a.endAttack();
        }
      },
      fiber$attackB :function _trc_Stage01_f_attackB(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        var i;
        
        boss = a.parent;
        
        if (f==0) {
          i = 0;
          for (; i<9 ; i++) {
            Tonyu.checkLoop();
            {
              a.shot({angle: i*45,spd: 1.5,size: 20,act: (function anonymous_2246(tama,f) {
                
                if (f==60) {
                  tama.changeTama(_this.tamaTargetPlayer);
                }
              })});
            }
          }
          
        }
        if (f>60) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      attackC :function _trc_Stage01_attackC(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%30==0) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackB));
        }
        if (f>=89) {
          a.endAttack();
        }
      },
      fiber$attackC :function _trc_Stage01_f_attackC(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%30==0) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackB));
        }
        if (f>=89) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      attackD :function _trc_Stage01_attackD(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%5==0) {
          a.shot({x: boss.x,y: boss.y,angle: _this.atanxy(_this.player.x-boss.x,_this.player.y-boss.y)+_this.rnd(11)-5,spd: 5,size: 20});
          
        }
        if (f>60) {
          a.endAttack();
        }
      },
      fiber$attackD :function _trc_Stage01_f_attackD(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%5==0) {
          a.shot({x: boss.x,y: boss.y,angle: _this.atanxy(_this.player.x-boss.x,_this.player.y-boss.y)+_this.rnd(11)-5,spd: 5,size: 20});
          
        }
        if (f>60) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"attackA":{"nowait":false},"attackB":{"nowait":false},"attackC":{"nowait":false},"attackD":{"nowait":false}},"fields":{"player":{},"boss":{},"tamakasoku":{},"tamaTargetPlayer":{},"e":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Stage02',
  shortName: 'Stage02',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Stage02_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$stage=_this;
        Tonyu.globals.$stageName="Stage02";
        Tonyu.globals.$hitCnt=0;
        Tonyu.globals.$time=0;
        _this.player = new Tonyu.classes.user.Player({x: 200,y: 350});
        
        _this.boss = new Tonyu.classes.user.Boss({x: 100,y: 50,maxhp: 2000});
        
        new Tonyu.classes.user.StageUI();
        _this.boss.vx=- 200;
        _this.boss.flag=0;
        _this.boss.attackState=0;
        _this.boss.movestartx=_this.boss.x;
        _this.boss.moveendtime=100;
        _this.boss.movetime=1000;
        _this.boss.cx=0;
        _this.color = Tonyu.globals.$ctx.rgba(60,60,255,1);
        
        _this.col2 = Tonyu.globals.$ctx.rgba(60,60,60,1);
        
        _this.tamakasoku = (function anonymous_385(tama,f) {
          
          if (tama.spd<=5) {
            tama.spdChange(tama.spd+0.05);
            
          }
          tama.screenoutdie();
        });
        
        _this.tamaTargetPlayer = {angle: "Player",spd: 0,color: Tonyu.globals.$ctx.rgba(60,60,60,1),act: _this.tamakasoku};
        
        _this.boss.act=(function anonymous_622(boss,f) {
          
          if (boss.flag>1&&boss.actf%30==0) {
            boss.attack(Tonyu.bindFunc(_this,_this.attackWall));
          }
          if (boss.movetime<boss.moveendtime) {
            boss.x=Tonyu.globals.$ease.easeOutQuart(boss.movetime,0,1,boss.moveendtime)*boss.vx+boss.movestartx;
            boss.movetime+=1;
            
          } else {
            boss.cx=- 100;
            boss.movetime=0;
            boss.movestartx=boss.x;
            boss.vx=- boss.vx;
            boss.attack(Tonyu.bindFunc(_this,_this.attackA));
            
          }
          if (boss.hp<boss.maxhp/4*(4-boss.flag)) {
            boss.flag+=1;
            if (boss.flag==3) {
              boss.attack(Tonyu.bindFunc(_this,_this.attackBEndless));
            }
            
          }
        });
      },
      fiber$main :function _trc_Stage02_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$stage=_this;
        Tonyu.globals.$stageName="Stage02";
        Tonyu.globals.$hitCnt=0;
        Tonyu.globals.$time=0;
        _this.player = new Tonyu.classes.user.Player({x: 200,y: 350});
        
        _this.boss = new Tonyu.classes.user.Boss({x: 100,y: 50,maxhp: 2000});
        
        new Tonyu.classes.user.StageUI();
        _this.boss.vx=- 200;
        _this.boss.flag=0;
        _this.boss.attackState=0;
        _this.boss.movestartx=_this.boss.x;
        _this.boss.moveendtime=100;
        _this.boss.movetime=1000;
        _this.boss.cx=0;
        _this.color = Tonyu.globals.$ctx.rgba(60,60,255,1);
        
        _this.col2 = Tonyu.globals.$ctx.rgba(60,60,60,1);
        
        _this.tamakasoku = (function anonymous_385(tama,f) {
          
          if (tama.spd<=5) {
            tama.spdChange(tama.spd+0.05);
            
          }
          tama.screenoutdie();
        });
        
        _this.tamaTargetPlayer = {angle: "Player",spd: 0,color: Tonyu.globals.$ctx.rgba(60,60,60,1),act: _this.tamakasoku};
        
        _this.boss.act=(function anonymous_622(boss,f) {
          
          if (boss.flag>1&&boss.actf%30==0) {
            boss.attack(Tonyu.bindFunc(_this,_this.attackWall));
          }
          if (boss.movetime<boss.moveendtime) {
            boss.x=Tonyu.globals.$ease.easeOutQuart(boss.movetime,0,1,boss.moveendtime)*boss.vx+boss.movestartx;
            boss.movetime+=1;
            
          } else {
            boss.cx=- 100;
            boss.movetime=0;
            boss.movestartx=boss.x;
            boss.vx=- boss.vx;
            boss.attack(Tonyu.bindFunc(_this,_this.attackA));
            
          }
          if (boss.hp<boss.maxhp/4*(4-boss.flag)) {
            boss.flag+=1;
            if (boss.flag==3) {
              boss.attack(Tonyu.bindFunc(_this,_this.attackBEndless));
            }
            
          }
        });
        
        _thread.retVal=_this;return;
      },
      attackWall :function _trc_Stage02_attackWall(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        a.shot({x: 30,y: 0,angle: 90,spd: 3,size: 60,color: Tonyu.bindFunc(_this,_this.color)});
        a.shot({x: 370,y: 0,angle: 90,spd: 3,size: 60,color: Tonyu.bindFunc(_this,_this.color)});
        a.endAttack();
      },
      fiber$attackWall :function _trc_Stage02_f_attackWall(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        a.shot({x: 30,y: 0,angle: 90,spd: 3,size: 60,color: Tonyu.bindFunc(_this,_this.color)});
        a.shot({x: 370,y: 0,angle: 90,spd: 3,size: 60,color: Tonyu.bindFunc(_this,_this.color)});
        a.endAttack();
        
        _thread.retVal=_this;return;
      },
      attackA :function _trc_Stage02_attackA(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%3==0) {
          a.shot({x: boss.x,y: boss.y,angle: "Player",spd: 1,size: 10,color: Tonyu.bindFunc(_this,_this.color)});
        }
        if (f>70) {
          a.endAttack();
        }
      },
      fiber$attackA :function _trc_Stage02_f_attackA(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%3==0) {
          a.shot({x: boss.x,y: boss.y,angle: "Player",spd: 1,size: 10,color: Tonyu.bindFunc(_this,_this.color)});
        }
        if (f>70) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      attackBEndless :function _trc_Stage02_attackBEndless(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%60==0) {
          a.eachTamas((function anonymous_1669(tama) {
            
            if (tama.f>1) {
              boss.attack(_this.attackC(tama.x,tama.y));
            }
          }));
          
        }
        if (f%120==0) {
          a.shot({x: boss.x,y: boss.y,angle: "Player",spd: 2,size: 20,color: _this.col2});
          
        }
      },
      fiber$attackBEndless :function _trc_Stage02_f_attackBEndless(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%60==0) {
          a.eachTamas((function anonymous_1669(tama) {
            
            if (tama.f>1) {
              boss.attack(_this.attackC(tama.x,tama.y));
            }
          }));
          
        }
        if (f%120==0) {
          a.shot({x: boss.x,y: boss.y,angle: "Player",spd: 2,size: 20,color: _this.col2});
          
        }
        
        _thread.retVal=_this;return;
      },
      attackC :function _trc_Stage02_attackC(x,y) {
        "use strict";
        var _this=this;
        
        return (function anonymous_1954(a,f) {
          var boss;
          var i;
          
          boss = a.parent;
          
          if (f==0) {
            i = 0;
            for (; i<9 ; i++) {
              Tonyu.checkLoop();
              {
                a.shot({x: x,y: y,angle: i*45,spd: 0.1,size: 10,color: Tonyu.bindFunc(_this,_this.color),act: _this.tamakasoku});
              }
            }
            
          }
          if (f>60) {
            a.endAttack();
          }
        });
      },
      fiber$attackC :function _trc_Stage02_f_attackC(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=(function anonymous_1954(a,f) {
          var boss;
          var i;
          
          boss = a.parent;
          
          if (f==0) {
            i = 0;
            for (; i<9 ; i++) {
              Tonyu.checkLoop();
              {
                a.shot({x: x,y: y,angle: i*45,spd: 0.1,size: 10,color: Tonyu.bindFunc(_this,_this.color),act: _this.tamakasoku});
              }
            }
            
          }
          if (f>60) {
            a.endAttack();
          }
        });return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"attackWall":{"nowait":false},"attackA":{"nowait":false},"attackBEndless":{"nowait":false},"attackC":{"nowait":false}},"fields":{"player":{},"boss":{},"color":{},"col2":{},"tamakasoku":{},"tamaTargetPlayer":{}}}
});
Tonyu.klass.define({
  fullName: 'user.StageUI',
  shortName: 'StageUI',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_StageUI_main() {
        "use strict";
        var _this=this;
        
        _this.bossGauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.bossGauge.resize(400,10);
        _this.bossGauge.x=200;
        _this.bossGauge.y=10;
        new Tonyu.classes.kernel.Button({left: 380,top: 0,width: 20,height: 10,padding: 0,text: "Title",onClick: (function anonymous_183() {
          
          _this.loadPage(Tonyu.classes.user.Title);
        })});
        while (Tonyu.globals.$bosshp>0) {
          Tonyu.checkLoop();
          _this.bossGauge.fillStyle="#800";
          _this.bossGauge.fillRect(0,0,400,10);
          _this.bossGauge.fillStyle="#1e1";
          _this.bossGauge.fillRect(0,0,Tonyu.globals.$bosshp/Tonyu.globals.$bossmaxhp*400,10);
          _this.update();
          
        }
        _this.bossGauge.die();
        _this.text = Tonyu.globals.$stageName+"\r\n当たった回数: "+Tonyu.globals.$hitCnt;
        
        new Tonyu.classes.kernel.Label({x: 200,y: 100,text: _this.text,size: 20,align: "center",fillStyle: "#ffffff"});
        _this.text = "時間: "+_this.floor(Tonyu.globals.$time/60)+"."+_this.floor((Tonyu.globals.$time/60-_this.floor(Tonyu.globals.$time/60))*100)+"秒";
        
        new Tonyu.classes.kernel.Label({x: 200,y: 150,text: _this.text,size: 20,align: "center",fillStyle: "#ffffff"});
        new Tonyu.classes.kernel.Button({left: 0,top: 0,width: Tonyu.globals.$screenWidth/2-50,padding: 10,text: "Title",onClick: (function anonymous_823() {
          
          _this.loadPage(Tonyu.classes.user.Title);
        })});
      },
      fiber$main :function _trc_StageUI_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.bossGauge=new Tonyu.classes.kernel.Panel({lifeKeeper: _this});
        _this.bossGauge.resize(400,10);
        _this.bossGauge.x=200;
        _this.bossGauge.y=10;
        
        _thread.enter(function _trc_StageUI_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              new Tonyu.classes.kernel.Button({left: 380,top: 0,width: 20,height: 10,padding: 0,text: "Title",onClick: (function anonymous_183() {
                
                _this.loadPage(Tonyu.classes.user.Title);
              })});
            case 1:
              if (!(Tonyu.globals.$bosshp>0)) { __pc=3     ; break; }
              _this.bossGauge.fillStyle="#800";
              _this.bossGauge.fillRect(0,0,400,10);
              _this.bossGauge.fillStyle="#1e1";
              _this.bossGauge.fillRect(0,0,Tonyu.globals.$bosshp/Tonyu.globals.$bossmaxhp*400,10);
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _this.bossGauge.die();
              _this.text = Tonyu.globals.$stageName+"\r\n当たった回数: "+Tonyu.globals.$hitCnt;
              
              new Tonyu.classes.kernel.Label({x: 200,y: 100,text: _this.text,size: 20,align: "center",fillStyle: "#ffffff"});
              _this.text = "時間: "+_this.floor(Tonyu.globals.$time/60)+"."+_this.floor((Tonyu.globals.$time/60-_this.floor(Tonyu.globals.$time/60))*100)+"秒";
              
              new Tonyu.classes.kernel.Label({x: 200,y: 150,text: _this.text,size: 20,align: "center",fillStyle: "#ffffff"});
              new Tonyu.classes.kernel.Button({left: 0,top: 0,width: Tonyu.globals.$screenWidth/2-50,padding: 10,text: "Title",onClick: (function anonymous_823() {
                
                _this.loadPage(Tonyu.classes.user.Title);
              })});
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"text":{},"bossGauge":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Title',
  shortName: 'Title',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Title_main() {
        "use strict";
        var _this=this;
        
        new Tonyu.classes.kernel.Button({left: Tonyu.globals.$screenWidth/2+25,top: Tonyu.globals.$screenHeight-100,width: Tonyu.globals.$screenWidth/2-50,padding: 10,text: "Stage01",onClick: (function anonymous_124() {
          
          _this.loadPage(Tonyu.classes.user.Stage01);
        })});
        new Tonyu.classes.kernel.Button({left: Tonyu.globals.$screenWidth/2+25,top: Tonyu.globals.$screenHeight-200,width: Tonyu.globals.$screenWidth/2-50,padding: 10,text: "Stage02",onClick: (function anonymous_285() {
          
          _this.loadPage(Tonyu.classes.user.Stage02);
        })});
        new Tonyu.classes.kernel.Button({left: Tonyu.globals.$screenWidth/2+25,top: Tonyu.globals.$screenHeight-300,width: Tonyu.globals.$screenWidth/2-50,padding: 10,text: "Stage03",onClick: (function anonymous_446() {
          
          _this.loadPage(Tonyu.classes.user.Stage03);
        })});
      },
      fiber$main :function _trc_Title_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Title_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              new Tonyu.classes.kernel.Button({left: Tonyu.globals.$screenWidth/2+25,top: Tonyu.globals.$screenHeight-100,width: Tonyu.globals.$screenWidth/2-50,padding: 10,text: "Stage01",onClick: (function anonymous_124() {
                
                _this.loadPage(Tonyu.classes.user.Stage01);
              })});
              new Tonyu.classes.kernel.Button({left: Tonyu.globals.$screenWidth/2+25,top: Tonyu.globals.$screenHeight-200,width: Tonyu.globals.$screenWidth/2-50,padding: 10,text: "Stage02",onClick: (function anonymous_285() {
                
                _this.loadPage(Tonyu.classes.user.Stage02);
              })});
              new Tonyu.classes.kernel.Button({left: Tonyu.globals.$screenWidth/2+25,top: Tonyu.globals.$screenHeight-300,width: Tonyu.globals.$screenWidth/2-50,padding: 10,text: "Stage03",onClick: (function anonymous_446() {
                
                _this.loadPage(Tonyu.classes.user.Stage03);
              })});
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{}}
});
Tonyu.klass.define({
  fullName: 'user.Utils',
  shortName: 'Utils',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Utils_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$getkey=(function anonymous_10(keyname) {
          
          if (_this.usePad) {
            if (keyname=="right") {
              return _this.getkey("right")||Tonyu.globals.$pad.getRight();
            }
            if (keyname=="left") {
              return _this.getkey("left")||Tonyu.globals.$pad.getLeft();
            }
            if (keyname=="up") {
              return _this.getkey("up")||Tonyu.globals.$pad.getUp();
            }
            if (keyname=="down") {
              return _this.getkey("down")||Tonyu.globals.$pad.getDown();
            }
            if (keyname=="jump") {
              return _this.getkey("space")||Tonyu.globals.$pad.getButton(1);
            }
            if (keyname=="dash") {
              return _this.getkey("shift")||Tonyu.globals.$pad.getButton(2);
            }
            if (keyname=="attack") {
              return _this.getkey("z")||Tonyu.globals.$pad.getButton(3);
            }
            
          } else {
            if (keyname=="jump") {
              return _this.getkey("space");
            }
            if (keyname=="dash") {
              return _this.getkey("shift");
            }
            return _this.getkey(keyname);
            
          }
        });
      },
      fiber$main :function _trc_Utils_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$getkey=(function anonymous_10(keyname) {
          
          if (_this.usePad) {
            if (keyname=="right") {
              return _this.getkey("right")||Tonyu.globals.$pad.getRight();
            }
            if (keyname=="left") {
              return _this.getkey("left")||Tonyu.globals.$pad.getLeft();
            }
            if (keyname=="up") {
              return _this.getkey("up")||Tonyu.globals.$pad.getUp();
            }
            if (keyname=="down") {
              return _this.getkey("down")||Tonyu.globals.$pad.getDown();
            }
            if (keyname=="jump") {
              return _this.getkey("space")||Tonyu.globals.$pad.getButton(1);
            }
            if (keyname=="dash") {
              return _this.getkey("shift")||Tonyu.globals.$pad.getButton(2);
            }
            if (keyname=="attack") {
              return _this.getkey("z")||Tonyu.globals.$pad.getButton(3);
            }
            
          } else {
            if (keyname=="jump") {
              return _this.getkey("space");
            }
            if (keyname=="dash") {
              return _this.getkey("shift");
            }
            return _this.getkey(keyname);
            
          }
        });
        
        _thread.retVal=_this;return;
      },
      min :function _trc_Utils_min(a,b) {
        "use strict";
        var _this=this;
        
        return a<b?a:b;
      },
      max :function _trc_Utils_max(a,b) {
        "use strict";
        var _this=this;
        
        return a>b?a:b;
      },
      newVec2 :function _trc_Utils_newVec2(x,y) {
        "use strict";
        var _this=this;
        
        return {x: x,y: y};
      },
      fiber$newVec2 :function _trc_Utils_f_newVec2(_thread,x,y) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal={x: x,y: y};return;
        
        
        _thread.retVal=_this;return;
      },
      newLine :function _trc_Utils_newLine(sx,sy,ex,ey) {
        "use strict";
        var _this=this;
        
        return [_this.newVec2(sx,sy),_this.newVec2(ex,ey)];
      },
      fiber$newLine :function _trc_Utils_f_newLine(_thread,sx,sy,ex,ey) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=[_this.newVec2(sx,sy),_this.newVec2(ex,ey)];return;
        
        
        _thread.retVal=_this;return;
      },
      newLine2 :function _trc_Utils_newLine2(x,y,angle,len) {
        "use strict";
        var _this=this;
        
        return [_this.newVec2(x,y),_this.newVec2(x+_this.cos(angle)*len,y+_this.sin(angle)*len)];
      },
      fiber$newLine2 :function _trc_Utils_f_newLine2(_thread,x,y,angle,len) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _thread.retVal=[_this.newVec2(x,y),_this.newVec2(x+_this.cos(angle)*len,y+_this.sin(angle)*len)];return;
        
        
        _thread.retVal=_this;return;
      },
      newLineFromCenter :function _trc_Utils_newLineFromCenter(x,y,angle,len) {
        "use strict";
        var _this=this;
        var sx;
        var sy;
        var ex;
        var ey;
        
        sx = x-_this.cos(angle)*len;
        
        sy = y-_this.sin(angle)*len;
        
        ex = x+_this.cos(angle)*len;
        
        ey = y+_this.sin(angle)*len;
        
        return [_this.newVec2(sx,sy),_this.newVec2(ex,ey)];
      },
      fiber$newLineFromCenter :function _trc_Utils_f_newLineFromCenter(_thread,x,y,angle,len) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var sx;
        var sy;
        var ex;
        var ey;
        
        sx = x-_this.cos(angle)*len;
        
        sy = y-_this.sin(angle)*len;
        
        ex = x+_this.cos(angle)*len;
        
        ey = y+_this.sin(angle)*len;
        
        _thread.retVal=[_this.newVec2(sx,sy),_this.newVec2(ex,ey)];return;
        
        
        _thread.retVal=_this;return;
      },
      lineExtendBoth :function _trc_Utils_lineExtendBoth(l,len) {
        "use strict";
        var _this=this;
        var angle;
        var sx;
        var sy;
        var ex;
        var ey;
        
        angle = _this.atanxy(l[1].x-l[0].x,l[1].y-l[0].y);
        
        sx = l[0].x-_this.cos(angle)*len;
        
        sy = l[0].y-_this.sin(angle)*len;
        
        ex = l[1].x+_this.cos(angle)*len;
        
        ey = l[1].y+_this.sin(angle)*len;
        
        return [_this.newVec2(sx,sy),_this.newVec2(ex,ey)];
      },
      fiber$lineExtendBoth :function _trc_Utils_f_lineExtendBoth(_thread,l,len) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var angle;
        var sx;
        var sy;
        var ex;
        var ey;
        
        angle = _this.atanxy(l[1].x-l[0].x,l[1].y-l[0].y);
        
        sx = l[0].x-_this.cos(angle)*len;
        
        sy = l[0].y-_this.sin(angle)*len;
        
        ex = l[1].x+_this.cos(angle)*len;
        
        ey = l[1].y+_this.sin(angle)*len;
        
        _thread.retVal=[_this.newVec2(sx,sy),_this.newVec2(ex,ey)];return;
        
        
        _thread.retVal=_this;return;
      },
      calcIntersectionPoint2 :function _trc_Utils_calcIntersectionPoint2(a,b) {
        "use strict";
        var _this=this;
        
        return _this.calcIntersectionPoint(a[0],a[1],b[0],b[1]);
      },
      fiber$calcIntersectionPoint2 :function _trc_Utils_f_calcIntersectionPoint2(_thread,a,b) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        _thread.enter(function _trc_Utils_ent_calcIntersectionPoint2(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$calcIntersectionPoint(_thread, a[0], a[1], b[0], b[1]);
              __pc=1;return;
            case 1:
              _thread.exit(_thread.retVal);return;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      calcIntersectionPoint :function _trc_Utils_calcIntersectionPoint(a,b,c,d) {
        "use strict";
        var _this=this;
        var bunbo;
        var ac;
        var r;
        var s;
        
        bunbo = (b.x-a.x)*(d.y-c.y)-(b.y-a.y)*(d.x-c.x);
        
        if (bunbo==0) {
          return false;
        }
        ac = _this.newVec2(c.x-a.x,c.y-a.y);
        
        r = ((d.y-c.y)*ac.x-(d.x-c.x)*ac.y)/bunbo;
        
        if (r<0||r>1) {
          return false;
        }
        s = ((b.y-a.y)*ac.x-(b.x-a.x)*ac.y)/bunbo;
        
        if (s<0||s>1) {
          return false;
        }
        return _this.newVec2(a.x+(b.x-a.x)*r,a.y+(b.y-a.y)*r);
      },
      fiber$calcIntersectionPoint :function _trc_Utils_f_calcIntersectionPoint(_thread,a,b,c,d) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var bunbo;
        var ac;
        var r;
        var s;
        
        bunbo = (b.x-a.x)*(d.y-c.y)-(b.y-a.y)*(d.x-c.x);
        
        if (bunbo==0) {
          _thread.retVal=false;return;
          
        }
        
        _thread.enter(function _trc_Utils_ent_calcIntersectionPoint(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
              _this.fiber$newVec2(_thread, c.x-a.x, c.y-a.y);
              __pc=1;return;
            case 1:
              ac=_thread.retVal;
              
              r = ((d.y-c.y)*ac.x-(d.x-c.x)*ac.y)/bunbo;
              
              if (!(r<0||r>1)) { __pc=2     ; break; }
              _thread.exit(false);return;
            case 2     :
              
              s = ((b.y-a.y)*ac.x-(b.x-a.x)*ac.y)/bunbo;
              
              if (!(s<0||s>1)) { __pc=3     ; break; }
              _thread.exit(false);return;
            case 3     :
              
              _this.fiber$newVec2(_thread, a.x+(b.x-a.x)*r, a.y+(b.y-a.y)*r);
              __pc=4;return;
            case 4:
              _thread.exit(_thread.retVal);return;
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"min":{"nowait":true},"max":{"nowait":true},"newVec2":{"nowait":false},"newLine":{"nowait":false},"newLine2":{"nowait":false},"newLineFromCenter":{"nowait":false},"lineExtendBoth":{"nowait":false},"calcIntersectionPoint2":{"nowait":false},"calcIntersectionPoint":{"nowait":false}},"fields":{"usePad":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Stage03',
  shortName: 'Stage03',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Stage03_main() {
        "use strict";
        var _this=this;
        
        Tonyu.globals.$stage=_this;
        Tonyu.globals.$stageName="Stage03";
        Tonyu.globals.$hitCnt=0;
        Tonyu.globals.$time=0;
        _this.player = new Tonyu.classes.user.Player({x: 200,y: 350});
        
        _this.boss = new Tonyu.classes.user.Boss({x: 200,y: 50,maxhp: 3000});
        
        new Tonyu.classes.user.StageUI();
        _this.boss.movestartx=_this.boss.x;
        _this.boss.vx=0;
        _this.boss.flag=0;
        _this.boss.cx=_this.boss.x;
        _this.flagmax = 3;
        
        
        _this.color = Tonyu.globals.$ctx.rgba(60,255,60,1);
        
        _this.col2 = Tonyu.globals.$ctx.rgba(60,60,60,1);
        
        _this.col3 = Tonyu.globals.$ctx.rgba(100,255,100,1);
        
        _this.tamakasoku = (function anonymous_381(tama,f) {
          
          if (tama.spd<=5) {
            tama.spdChange(tama.spd+0.05);
            
          }
          tama.screenoutdie();
        });
        
        _this.tamaTargetPlayerA = {angle: "Player",color: Tonyu.globals.$ctx.rgba(60,100,60,1),act: (function anonymous_581(tama,f) {
          
          tama.x-=tama.vx;
          tama.y-=tama.vy;
          tama.screenoutdie();
          if (tama.size>5) {
            tama.size-=0.5;
          }
          if (f==60) {
            tama.changeTama(_this.tamaTargetPlayerB);
            tama.spd+=1;
            
          }
        })};
        
        _this.tamaTargetPlayerB = {angle: "Player",color: _this.col3,act: (function anonymous_911(tama,f) {
          
          tama.screenoutdie();
          if (tama.size<20) {
            tama.size+=0.5;
          }
          if (f==60) {
            tama.changeTama(_this.tamaTargetPlayerA);
          }
        })};
        
        _this.boss.act=(function anonymous_1082(boss,f) {
          var _it_15286;
          
          if (! boss.isAttack) {
            if (f<60) {
              boss.x=Tonyu.globals.$ease.easeOutQuart(f,0,1,60)*boss.vx+boss.movestartx;
              
            } else {
              if (boss.flag==1) {
                _this.ba=boss.attack(Tonyu.bindFunc(_this,_this.actA),"actA");
                
              }
              if (boss.flag==2) {
                _this.ba=boss.attack(Tonyu.bindFunc(_this,_this.actC),"actC");
                
              }
              if (boss.flag==3) {
                _this.ba=boss.attack(Tonyu.bindFunc(_this,_this.actD),"actD");
                
              }
              
            }
            
          }
          if (boss.hp<boss.maxhp/_this.flagmax*(_this.flagmax-boss.flag)) {
            if (boss.flag!=0) {
              _this.ba.endAttack();
            }
            boss.flag+=1;
            boss.movestartx=boss.x;
            boss.vx=200-boss.x;
            boss.f=0;
            _it_15286=Tonyu.iterator(_this.all(Tonyu.classes.user.BossTama),1);
            while(_it_15286.next()) {
              _this.e=_it_15286[0];
              
              _this.e.die();
              
            }
            
          }
        });
      },
      fiber$main :function _trc_Stage03_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        Tonyu.globals.$stage=_this;
        Tonyu.globals.$stageName="Stage03";
        Tonyu.globals.$hitCnt=0;
        Tonyu.globals.$time=0;
        _this.player = new Tonyu.classes.user.Player({x: 200,y: 350});
        
        _this.boss = new Tonyu.classes.user.Boss({x: 200,y: 50,maxhp: 3000});
        
        new Tonyu.classes.user.StageUI();
        _this.boss.movestartx=_this.boss.x;
        _this.boss.vx=0;
        _this.boss.flag=0;
        _this.boss.cx=_this.boss.x;
        _this.flagmax = 3;
        
        
        _this.color = Tonyu.globals.$ctx.rgba(60,255,60,1);
        
        _this.col2 = Tonyu.globals.$ctx.rgba(60,60,60,1);
        
        _this.col3 = Tonyu.globals.$ctx.rgba(100,255,100,1);
        
        _this.tamakasoku = (function anonymous_381(tama,f) {
          
          if (tama.spd<=5) {
            tama.spdChange(tama.spd+0.05);
            
          }
          tama.screenoutdie();
        });
        
        _this.tamaTargetPlayerA = {angle: "Player",color: Tonyu.globals.$ctx.rgba(60,100,60,1),act: (function anonymous_581(tama,f) {
          
          tama.x-=tama.vx;
          tama.y-=tama.vy;
          tama.screenoutdie();
          if (tama.size>5) {
            tama.size-=0.5;
          }
          if (f==60) {
            tama.changeTama(_this.tamaTargetPlayerB);
            tama.spd+=1;
            
          }
        })};
        
        _this.tamaTargetPlayerB = {angle: "Player",color: _this.col3,act: (function anonymous_911(tama,f) {
          
          tama.screenoutdie();
          if (tama.size<20) {
            tama.size+=0.5;
          }
          if (f==60) {
            tama.changeTama(_this.tamaTargetPlayerA);
          }
        })};
        
        _this.boss.act=(function anonymous_1082(boss,f) {
          var _it_15286;
          
          if (! boss.isAttack) {
            if (f<60) {
              boss.x=Tonyu.globals.$ease.easeOutQuart(f,0,1,60)*boss.vx+boss.movestartx;
              
            } else {
              if (boss.flag==1) {
                _this.ba=boss.attack(Tonyu.bindFunc(_this,_this.actA),"actA");
                
              }
              if (boss.flag==2) {
                _this.ba=boss.attack(Tonyu.bindFunc(_this,_this.actC),"actC");
                
              }
              if (boss.flag==3) {
                _this.ba=boss.attack(Tonyu.bindFunc(_this,_this.actD),"actD");
                
              }
              
            }
            
          }
          if (boss.hp<boss.maxhp/_this.flagmax*(_this.flagmax-boss.flag)) {
            if (boss.flag!=0) {
              _this.ba.endAttack();
            }
            boss.flag+=1;
            boss.movestartx=boss.x;
            boss.vx=200-boss.x;
            boss.f=0;
            _it_15286=Tonyu.iterator(_this.all(Tonyu.classes.user.BossTama),1);
            while(_it_15286.next()) {
              _this.e=_it_15286[0];
              
              _this.e.die();
              
            }
            
          }
        });
        
        _thread.retVal=_this;return;
      },
      actA :function _trc_Stage03_actA(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%120==0) {
          boss.cx=boss.x;
          boss.vx=- boss.vx;
          
        }
        if (f==0) {
          boss.cx=boss.x;
          boss.vx=100-boss.x;
          
        }
        if (f==120) {
          boss.cx=boss.x;
          boss.vx=200;
          
        }
        if (f%120<60) {
          boss.x=Tonyu.globals.$ease.easeOutQuart(f%120,0,1,60)*boss.vx+boss.cx;
        }
        if (f%120==60) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackA));
          
        }
      },
      fiber$actA :function _trc_Stage03_f_actA(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%120==0) {
          boss.cx=boss.x;
          boss.vx=- boss.vx;
          
        }
        if (f==0) {
          boss.cx=boss.x;
          boss.vx=100-boss.x;
          
        }
        if (f==120) {
          boss.cx=boss.x;
          boss.vx=200;
          
        }
        if (f%120<60) {
          boss.x=Tonyu.globals.$ease.easeOutQuart(f%120,0,1,60)*boss.vx+boss.cx;
        }
        if (f%120==60) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackA));
          
        }
        
        _thread.retVal=_this;return;
      },
      actB :function _trc_Stage03_actB(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%120==0) {
          boss.cx=boss.x;
          boss.vx=- boss.vx;
          
        }
        if (f==0) {
          boss.cx=boss.x;
          boss.vx=100-boss.x;
          
        }
        if (f==120) {
          boss.cx=boss.x;
          boss.vx=200;
          
        }
        if (f%120<60) {
          boss.x=Tonyu.globals.$ease.easeOutQuart(f%120,0,1,60)*boss.vx+boss.cx;
        }
        if (f%120==0) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackA));
          
        }
      },
      fiber$actB :function _trc_Stage03_f_actB(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%120==0) {
          boss.cx=boss.x;
          boss.vx=- boss.vx;
          
        }
        if (f==0) {
          boss.cx=boss.x;
          boss.vx=100-boss.x;
          
        }
        if (f==120) {
          boss.cx=boss.x;
          boss.vx=200;
          
        }
        if (f%120<60) {
          boss.x=Tonyu.globals.$ease.easeOutQuart(f%120,0,1,60)*boss.vx+boss.cx;
        }
        if (f%120==0) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackA));
          
        }
        
        _thread.retVal=_this;return;
      },
      actC :function _trc_Stage03_actC(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f==0) {
          boss.cx=boss.x;
          boss.vx=20-boss.x;
          
        }
        if (f==60) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackC3));
          boss.cx=boss.x;
          boss.vx=380-boss.x;
          
        }
        if (f<60) {
          boss.x=Tonyu.globals.$ease.easeOutQuart(f,0,1,60)*boss.vx+boss.cx;
        }
        if (f>=60&&f<=180) {
          boss.x=Tonyu.globals.$ease.linear(f-60,0,1,120)*boss.vx+boss.cx;
          if (f%10==0) {
            a.apendattack(Tonyu.bindFunc(_this,_this.attackB));
            
          }
          
        }
        if (f==180) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackC3));
          
        }
        if (f==180+60) {
          a.f=- 1;
          
        }
      },
      fiber$actC :function _trc_Stage03_f_actC(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f==0) {
          boss.cx=boss.x;
          boss.vx=20-boss.x;
          
        }
        if (f==60) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackC3));
          boss.cx=boss.x;
          boss.vx=380-boss.x;
          
        }
        if (f<60) {
          boss.x=Tonyu.globals.$ease.easeOutQuart(f,0,1,60)*boss.vx+boss.cx;
        }
        if (f>=60&&f<=180) {
          boss.x=Tonyu.globals.$ease.linear(f-60,0,1,120)*boss.vx+boss.cx;
          if (f%10==0) {
            a.apendattack(Tonyu.bindFunc(_this,_this.attackB));
            
          }
          
        }
        if (f==180) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackC3));
          
        }
        if (f==180+60) {
          a.f=- 1;
          
        }
        
        _thread.retVal=_this;return;
      },
      actD :function _trc_Stage03_actD(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f==0) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackC3));
          
        }
        if (f==60) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackC2));
          
        }
        if (f==180) {
          a.f=- 1;
          
        }
      },
      fiber$actD :function _trc_Stage03_f_actD(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f==0) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackC3));
          
        }
        if (f==60) {
          a.apendattack(Tonyu.bindFunc(_this,_this.attackC2));
          
        }
        if (f==180) {
          a.f=- 1;
          
        }
        
        _thread.retVal=_this;return;
      },
      attackA :function _trc_Stage03_attackA(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        a.shot({x: boss.x,y: boss.y,angle: f*32,spd: 1.5,size: 20,color: Tonyu.bindFunc(_this,_this.color)});
        if (f>60) {
          a.endAttack();
        }
      },
      fiber$attackA :function _trc_Stage03_f_attackA(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        a.shot({x: boss.x,y: boss.y,angle: f*32,spd: 1.5,size: 20,color: Tonyu.bindFunc(_this,_this.color)});
        if (f>60) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      attackB :function _trc_Stage03_attackB(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%20==0) {
          a.shot({angle: 90,spd: 0,size: 20,color: Tonyu.bindFunc(_this,_this.color),act: _this.tamakasoku});
        }
        if (f>60) {
          a.endAttack();
        }
      },
      fiber$attackB :function _trc_Stage03_f_attackB(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%20==0) {
          a.shot({angle: 90,spd: 0,size: 20,color: Tonyu.bindFunc(_this,_this.color),act: _this.tamakasoku});
        }
        if (f>60) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      attackC :function _trc_Stage03_attackC(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%10==0) {
          a.shot({angle: "Player",spd: 0.5+f/15,size: 20,color: _this.col2});
        }
        if (f>30) {
          a.endAttack();
        }
      },
      fiber$attackC :function _trc_Stage03_f_attackC(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%10==0) {
          a.shot({angle: "Player",spd: 0.5+f/15,size: 20,color: _this.col2});
        }
        if (f>30) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      attackC2 :function _trc_Stage03_attackC2(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f%10==0) {
          a.shot({angle: "Player",spd: 1+f/20,size: 20,color: _this.col3,act: _this.tamaTargetPlayerB.act});
        }
        if (f>40) {
          a.endAttack();
        }
      },
      fiber$attackC2 :function _trc_Stage03_f_attackC2(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f%10==0) {
          a.shot({angle: "Player",spd: 1+f/20,size: 20,color: _this.col3,act: _this.tamaTargetPlayerB.act});
        }
        if (f>40) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      attackC3 :function _trc_Stage03_attackC3(a,f) {
        "use strict";
        var _this=this;
        var boss;
        
        boss = a.parent;
        
        if (f==0) {
          a.shot({angle: 90,spd: 6,size: 40,color: _this.col3,act: (function anonymous_4208(tama,f) {
            
            if (f%3==0) {
              tama.parent.shot({x: tama.x,y: tama.y,angle: "Player",spd: 3,size: 20,color: _this.col2});
            }
            tama.screenoutdie();
          })});
        }
        if (f>120) {
          a.endAttack();
        }
      },
      fiber$attackC3 :function _trc_Stage03_f_attackC3(_thread,a,f) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var boss;
        
        boss = a.parent;
        
        if (f==0) {
          a.shot({angle: 90,spd: 6,size: 40,color: _this.col3,act: (function anonymous_4208(tama,f) {
            
            if (f%3==0) {
              tama.parent.shot({x: tama.x,y: tama.y,angle: "Player",spd: 3,size: 20,color: _this.col2});
            }
            tama.screenoutdie();
          })});
        }
        if (f>120) {
          a.endAttack();
        }
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"actA":{"nowait":false},"actB":{"nowait":false},"actC":{"nowait":false},"actD":{"nowait":false},"attackA":{"nowait":false},"attackB":{"nowait":false},"attackC":{"nowait":false},"attackC2":{"nowait":false},"attackC3":{"nowait":false}},"fields":{"player":{},"boss":{},"flagmax":{},"ba":{},"color":{},"col2":{},"col3":{},"tamakasoku":{},"tamaTargetPlayerA":{},"tamaTargetPlayerB":{},"e":{}}}
});

//# sourceMappingURL=concat.js.map